#include <ApplicationServices/ApplicationServices.h>

int main(int argc, char** argv)
{
    if (argc != 2) {
        printf("no font name specified\n");
        return 1;
    }

    CFStringRef name = CFStringCreateWithCString(kCFAllocatorDefault,
                                                 argv[1],
                                                 kCFStringEncodingASCII);
    if (!name) {
        printf("CFStringCreateWithCString failed!\n");
        return 1;
    }

    ATSFontRef fontRef = ATSFontFindFromPostScriptName(name, 
                                                       kATSOptionFlagsDefault);
    if (!fontRef) {
        printf("font %s not found (NB: use the PostScript name)\n", argv[1]);
        return 1;
    }

    CFRelease(name);

    ATSFontMetrics atsMetrics;
    OSStatus err = ATSFontGetHorizontalMetrics(fontRef,
                                               kATSOptionFlagsDefault,
                                               &atsMetrics);
    if (err != noErr) {
        printf("ATSFontGetHorizontalMetrics returned error %d\n", err);
        return 1;
    }

    printf("Metrics for %s\n  ascent = %+.3f\n descent = %+.3f\n leading = %+.3f\n",
           argv[1], atsMetrics.ascent, atsMetrics.descent, atsMetrics.leading);
    return 0;
}
